﻿Dir.chdir(File.dirname(__FILE__))
$:.unshift Dir.pwd

load 'Table.rb'
load 'Tone.rb'
load 'Color.rb'
load 'RPG.rb'
load 'RPG_Modification.rb'

class RXData

  def setup(path)
    Dir.chdir(path) # Data文件夹
    instance_variables.each { |iv| remove_instance_variable(iv) }
  end

  def load_file(filename)
    var = "@#{filename}"
    instance_variable_set(var, load_data(filename + ".rxdata"))
    if filename =~ /Map/
      current_note = instance_variable_get(var).instance_variable_get(:@note)
      unless current_note
        instance_variable_get(var).instance_variable_set(:@note, "")
      end 
    else
      instance_variable_get(var).each do |i|
        i.instance_variable_set(:@note, "") unless i.instance_variable_get(:@note)
      end
    end
  end

  def load_data(filename)
    File.open(filename, "rb") { |f| return Marshal.load(f) }
  end

  def save_data(obj, filename)
    File.open(filename, "wb") { |f| Marshal.dump(obj, f) }
  end

  def get_array_length(filename)
    instance_variable_get("@#{filename}").length
  end

  def get_data(filename, index, type)
    str = instance_variable_get("@#{filename}")[index].send(type)
    # 将Mutable String 转为System.String 并以UTF-8编码传回
    System::String.new(str.force_encoding("UTF-8"))
  end

  def get_map_data(filename, type)
    str = instance_variable_get("@#{filename}").send(type)
    System::String.new(str.force_encoding("UTF-8"))
  end

  def save_variable(filename, index, varname, string)
    var = instance_variable_get("@#{filename}")[index]
    var.send("#{varname}=", string.to_s.gsub("\\r\\n", "\r\n"))
    #instance_variable_set("@#{varname}", string.to_s)
  end

  def save_map_variable(filename, varname, string)
    var = instance_variable_get("@#{filename}")
    var.send("#{varname}=", string.to_s)
    #instance_variable_set("@#{varname}", string.to_s)
  end

  def save_all
    instance_variables.each do |iv|
      save_data(instance_variable_get(iv), iv.to_s.delete("@") + ".rxdata")
    end
  end
end